import { IRedisService } from './redis';
/**
 * 基础信息的工厂服务
 */
export interface IBaseInfoFactory {
    /**
     * 获取基础节点信息
     */
    getInfo: () => {
        pid: number;
        currentTask: number;
        maxTask: number;
    };
    /**
     * 最大的任务数量
     */
    maxTask: number;
    /**
     * 当前的任务数量
     */
    currentTask: number;
}
/**
 * 基础信息服务
 */
export declare class BaseInfoFactory implements IBaseInfoFactory {
    private redisService;
    private _maxTask;
    private _currentTask;
    constructor(redisService: IRedisService);
    maxTask: number;
    currentTask: number;
    getInfo(): {
        pid: number;
        currentTask: number;
        maxTask: number;
    };
}
export declare const BaseInfo: symbol;
export declare const baseInfoFactory: any;
