/// <reference types="node" />
import { EventEmitter } from "events";
/**
 * 获取配置文件的信息
 */
export declare class Configurator extends EventEmitter {
    private automaticConfigReload;
    config: any;
    oldConfig: any;
    /**
     * 构造
     * @param automaticConfigReload 是否自动获取配置文件的更改
     */
    constructor(automaticConfigReload?: boolean);
    /**
     * 更新配置文件信息
     * @param file 文件的路径
     */
    updateConfig(file: string): void;
}
/**
 * 配置文件服务
 */
export declare class ConfigService implements IConfigService {
    private configurator;
    constructor();
    /**
     * 初始化配置文件
     * @param filePath 配置文件路径
     * @param automaticConfigReload
     */
    initConfig(filePath: string, automaticConfigReload?: boolean): void | any;
    readonly config: any;
}
export interface IConfigService {
    initConfig: (filePath: string, automaticConfigReload: boolean) => void | any;
    config: TypedPropertyDescriptor<number>;
}
export declare const ConfigFactory: symbol;
export declare const configFactory: ConfigService;
