import { ProxyInfoFactory } from "../../../services/proxyinfo";
import { AgendaService } from '../../../services/agenda';
/**
 * 节点基础信息Controller
 */
export declare class NodeCtrl {
    private baseInfoFactory;
    private agendaService;
    /**
     * 构造函数
     * @param baseInfoFactory 基础信息工厂方法,用来返回节点的基础信息
     */
    constructor(baseInfoFactory: ProxyInfoFactory, agendaService: AgendaService);
    /**
     * 获取一个代理节点的基础信息
     */
    info(): any;
    /**
     * 重启一个代理节点
     */
    execute(ip: string): Promise<any>;
    /**
     * 设置代理服务器的账号信息
     * @param account
     * @param password
     * @param server
     */
    setProxyInfo(account: string, password: string, server: string): Promise<any>;
}
