"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_express_decorators_1 = require("ts-express-decorators");
var result_1 = require("../../../middlewares/result");
var proxyinfo_1 = require("../../../services/proxyinfo");
var agenda_1 = require("../../../services/agenda");
/**
 * 节点基础信息Controller
 */
var NodeCtrl = (function () {
    /**
     * 构造函数
     * @param baseInfoFactory 基础信息工厂方法,用来返回节点的基础信息
     */
    function NodeCtrl(baseInfoFactory, agendaService) {
        this.baseInfoFactory = baseInfoFactory;
        this.agendaService = agendaService;
    }
    /**
     * 获取一个代理节点的基础信息
     */
    NodeCtrl.prototype.info = function () {
        return this.baseInfoFactory.getInfo();
    };
    /**
     * 重启一个代理节点
     */
    NodeCtrl.prototype.execute = function (ip) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.agendaService.executeProxy(ip)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * 设置代理服务器的账号信息
     * @param account
     * @param password
     * @param server
     */
    NodeCtrl.prototype.setProxyInfo = function (account, password, server) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.baseInfoFactory.proxyInfo = {
                            account: account,
                            password: password,
                            server: server
                        };
                        return [4 /*yield*/, this.agendaService.executeProxy()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return NodeCtrl;
}());
__decorate([
    ts_express_decorators_1.Get("/"),
    ts_express_decorators_1.UseAfter(result_1.ResultMiddleware),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Object)
], NodeCtrl.prototype, "info", null);
__decorate([
    ts_express_decorators_1.Post("/restart"),
    ts_express_decorators_1.UseAfter(result_1.ResultMiddleware),
    __param(0, ts_express_decorators_1.BodyParams('ip')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], NodeCtrl.prototype, "execute", null);
__decorate([
    ts_express_decorators_1.Post("/setProxyInfo"),
    ts_express_decorators_1.UseAfter(result_1.ResultMiddleware),
    __param(0, ts_express_decorators_1.BodyParams('account')),
    __param(1, ts_express_decorators_1.BodyParams('password')),
    __param(2, ts_express_decorators_1.BodyParams('server')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, String]),
    __metadata("design:returntype", Promise)
], NodeCtrl.prototype, "setProxyInfo", null);
NodeCtrl = __decorate([
    ts_express_decorators_1.Controller("/proxy"),
    __param(0, ts_express_decorators_1.Inject(proxyinfo_1.ProxyInfoFactory)),
    __param(1, ts_express_decorators_1.Inject(agenda_1.AgendaService)),
    __metadata("design:paramtypes", [proxyinfo_1.ProxyInfoFactory,
        agenda_1.AgendaService])
], NodeCtrl);
exports.NodeCtrl = NodeCtrl;
//# sourceMappingURL=index.js.map