/// <reference types="express" />
import * as Express from "express";
import { ProxyInfoFactory } from "../../../services/proxyinfo";
import { AgendaService } from '../../../services/agenda';
/**
 * 节点基础信息Controller
 */
export declare class NodeCtrl {
    private baseInfoFactory;
    private agendaService;
    /**
     * 构造函数
     * @param baseInfoFactory 基础信息工厂方法,用来返回节点的基础信息
     */
    constructor(baseInfoFactory: ProxyInfoFactory, agendaService: AgendaService);
    /**
     * 获取一个代理节点的基础信息
     */
    info(req: Express.Request, res: Express.Response): any;
}
