"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Express = require("express");
var ts_express_decorators_1 = require("ts-express-decorators");
var server_1 = require("react-dom/server");
var react_router_1 = require("react-router");
var proxyinfo_1 = require("../../../services/proxyinfo");
var agenda_1 = require("../../../services/agenda");
var routes = {};
/**
 * 节点基础信息Controller
 */
var NodeCtrl = (function () {
    /**
     * 构造函数
     * @param baseInfoFactory 基础信息工厂方法,用来返回节点的基础信息
     */
    function NodeCtrl(baseInfoFactory, agendaService) {
        this.baseInfoFactory = baseInfoFactory;
        this.agendaService = agendaService;
    }
    /**
     * 获取一个代理节点的基础信息
     */
    NodeCtrl.prototype.info = function (req, res) {
        react_router_1.match({ routes: routes, location: req.url }, function (error, redirectLocation, renderProps) {
            if (error) {
                res.status(500).send(error.message);
            }
            else if (redirectLocation) {
                res.redirect(302, redirectLocation.pathname + redirectLocation.search);
            }
            else if (renderProps) {
                res.status(200).send(server_1.renderToString(<react_router_1.RoutingContext {...renderProps}/>));
            }
            else {
                res.status(404).send('Not found');
            }
        });
    };
    return NodeCtrl;
}());
__decorate([
    ts_express_decorators_1.All("/")
    // @UseAfter(ResultMiddleware)
    ,
    __param(0, ts_express_decorators_1.Request()),
    __param(1, ts_express_decorators_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Object)
], NodeCtrl.prototype, "info", null);
NodeCtrl = __decorate([
    ts_express_decorators_1.Controller("/test"),
    __param(0, ts_express_decorators_1.Inject(proxyinfo_1.ProxyInfoFactory)),
    __param(1, ts_express_decorators_1.Inject(agenda_1.AgendaService)),
    __metadata("design:paramtypes", [proxyinfo_1.ProxyInfoFactory,
        agenda_1.AgendaService])
], NodeCtrl);
exports.NodeCtrl = NodeCtrl;
//# sourceMappingURL=index.jsx.map