"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts_log_debug_1 = require("ts-log-debug");
/**
 * 记录方法调用日志的装饰器Log
 * 调用元方法
 * 记录方法的调用参数以及返回值
 */
exports.Log = function () {
    return function (target, key, descriptor) {
        var originalMethod = descriptor.value;
        // 覆盖value
        descriptor.value = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var a = args.map(function (a) { return JSON.stringify(a); }).join();
            var result = originalMethod.apply(this, args);
            var r = JSON.stringify(result);
            ts_log_debug_1.$log.trace("Call: " + key + "(" + a + ") => " + r);
            return result;
        };
        return descriptor;
    };
};
//# sourceMappingURL=log.func.js.map