"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Express = require("express");
var ts_express_decorators_1 = require("ts-express-decorators");
var ts_httpexceptions_1 = require("ts-httpexceptions");
var ts_log_debug_1 = require("ts-log-debug");
var result_1 = require("../services/result");
/**
 * 全局错误中间件
 */
var GlobalErrorHandlerMiddleware = (function () {
    function GlobalErrorHandlerMiddleware(resultService) {
        this.resultService = resultService;
    }
    GlobalErrorHandlerMiddleware.prototype.use = function (error, request, response, next) {
        if (response.headersSent) {
            return next(error);
        }
        var toHTML = function (message) {
            if (message === void 0) { message = ""; }
            return message.replace(/\n/gi, "<br />");
        };
        if (error instanceof ts_httpexceptions_1.Exception) {
            ts_log_debug_1.$log.error(error);
            response.status(error.status).send(this.resultService.getErrorData(error));
            return next();
        }
        if (typeof error === "string") {
            response.status(404).send(toHTML(error));
            return next();
        }
        ts_log_debug_1.$log.error(error);
        response.status(error.status || 500).send("Internal Error");
        return next();
    };
    return GlobalErrorHandlerMiddleware;
}());
__decorate([
    __param(0, ts_express_decorators_1.Err()),
    __param(1, ts_express_decorators_1.Request()),
    __param(2, ts_express_decorators_1.Response()),
    __param(3, ts_express_decorators_1.Next()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, Function]),
    __metadata("design:returntype", Object)
], GlobalErrorHandlerMiddleware.prototype, "use", null);
GlobalErrorHandlerMiddleware = __decorate([
    ts_express_decorators_1.MiddlewareError(),
    __metadata("design:paramtypes", [result_1.ResultService])
], GlobalErrorHandlerMiddleware);
exports.GlobalErrorHandlerMiddleware = GlobalErrorHandlerMiddleware;
//# sourceMappingURL=_error.js.map