"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_express_decorators_1 = require("ts-express-decorators");
var baseinfo_1 = require("../../../services/baseinfo");
var result_1 = require("../../../middlewares/result");
/**
 * 节点基础信息Controller
 */
var NodeCtrl = (function () {
    /**
     * 构造函数
     * @param baseInfoFactory 基础信息工厂方法,用来返回节点的基础信息
     */
    function NodeCtrl(baseInfoFactory) {
        this.baseInfoFactory = baseInfoFactory;
    }
    /**
     * 获取单个节点的详情信息74
     *     路由信息为 /
     *     返回数据后使用包装器包装
     */
    NodeCtrl.prototype.getBaseInfo = function () {
        return this.baseInfoFactory.getInfo();
    };
    /**
     * 设置当前节点的最大任务数量
     * @param maxTask 最大任务数量
     */
    NodeCtrl.prototype.setMaxTask = function (maxTask) {
        this.baseInfoFactory.maxTask = maxTask;
    };
    /**
     * 执行一次爬取操作
     */
    NodeCtrl.prototype.execute = function () {
        this.baseInfoFactory.currentTask += 1;
        return {};
    };
    return NodeCtrl;
}());
__decorate([
    ts_express_decorators_1.Get("/"),
    ts_express_decorators_1.UseAfter(result_1.ResultMiddleware),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Object)
], NodeCtrl.prototype, "getBaseInfo", null);
__decorate([
    ts_express_decorators_1.Post("/setMaxTask"),
    ts_express_decorators_1.UseAfter(result_1.ResultMiddleware),
    __param(0, ts_express_decorators_1.BodyParams('maxTask')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Object)
], NodeCtrl.prototype, "setMaxTask", null);
__decorate([
    ts_express_decorators_1.Post("/execute"),
    ts_express_decorators_1.UseAfter(result_1.ResultMiddleware),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NodeCtrl.prototype, "execute", null);
NodeCtrl = __decorate([
    ts_express_decorators_1.Controller("/node"),
    __param(0, ts_express_decorators_1.Inject(baseinfo_1.BaseInfoFactory)),
    __metadata("design:paramtypes", [Object])
], NodeCtrl);
exports.NodeCtrl = NodeCtrl;
//# sourceMappingURL=index.js.map