import { ServerLoader, IServerLifecycle } from 'ts-express-decorators';
import { AgendaService } from './services/agenda';
import { ConfigService } from "./services/config";
/**
 * 服务的启动文件
 */
export declare class Server extends ServerLoader implements IServerLifecycle {
    /**
     * 构造
     * 覆盖基类的信息
     * 挂载controller
     */
    constructor();
    /**
     * 设置自定义中间件
     * @returns {void | Promise<any>}
     */
    $onMountingMiddlewares(): void | Promise<any>;
    /**
     * lifecircle onReady
     */
    $onReady(): void;
    /**
     * lifecircle onServerInitError
     * @param err 错误信息
     */
    $onServerInitError(err: Error): void;
    /**
     * lifecircle 路由加载完后hook的方法
     * 加载定时任务服务中间件
     * 加载全局错误中间件
     * 手动启动http服务
     */
    $afterRoutesInit(agendaFactory: AgendaService, config: ConfigService): void;
    /**
     * 初始化的lifecircle
     */
    $onInit(): void;
    /**
     * 初始化服务
     * 打开log的时间
     */
    static Initialize(): Promise<any>;
}
