"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_express_decorators_1 = require("ts-express-decorators");
var ip = require("ip");
var config_1 = require("./config");
/**
 * 基础信息服务
 */
var BaseInfoFactory = (function () {
    /**
     * 设置基础信息
     * 读取配置文件中maxTask字段
     */
    function BaseInfoFactory(configFactory) {
        this.configFactory = configFactory;
        this._maxTask = 0;
        this._currentTask = 0;
        if (!configFactory || !configFactory.config) {
            return;
        }
        this.maxTask = configFactory.config.taskInfo.maxTask || 10;
    }
    Object.defineProperty(BaseInfoFactory.prototype, "maxTask", {
        /**
         * 设置最大任务数
         */
        set: function (val) {
            this._maxTask = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseInfoFactory.prototype, "currentTask", {
        /**
         * 设置当前的任务数量
         */
        set: function (val) {
            this._currentTask = val;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * 获取基础信息
     * pid
     * currentTask
     * maxTask
     */
    BaseInfoFactory.prototype.getInfo = function () {
        return {
            type: "crawler.node",
            pid: process.pid,
            currentTask: this._currentTask,
            maxTask: this._maxTask,
            callIp: this.configFactory.config.baseInfo.ip,
            callPort: this.configFactory.config.baseInfo.port,
            ip: ip.address(),
            lastUpdateTime: Date.now()
        };
    };
    /**
     * 获取代理节点的基础信息
     */
    BaseInfoFactory.prototype.getProxyInfo = function () {
        return Object.assign({}, this.getInfo(), {
            type: "crawler.proxy"
        });
    };
    return BaseInfoFactory;
}());
BaseInfoFactory = __decorate([
    ts_express_decorators_1.Service(),
    __param(0, ts_express_decorators_1.Inject(config_1.ConfigService)),
    __metadata("design:paramtypes", [config_1.ConfigService])
], BaseInfoFactory);
exports.BaseInfoFactory = BaseInfoFactory;
// 工厂方法注册
ts_express_decorators_1.InjectorService.factory(BaseInfoFactory, ts_express_decorators_1.InjectorService.invoke(BaseInfoFactory));
//# sourceMappingURL=baseinfo.js.map