/// <reference types="agenda" />
import * as Agenda from 'agenda';
import { IConfigService } from './config';
import { RedisService } from "./redis";
import { BaseInfoFactory } from './baseinfo';
import { ProxyInfoFactory } from './proxyinfo';
/**
 * agenda服务
 */
export declare class AgendaService {
    private configFactory;
    private redisFactory;
    private baseInfoFactory;
    private proxyInfoFactory;
    agenda: Agenda;
    /**
     * 构造函数
     * @param configFactory 配置文件服务类
     * @param redisService  redis服务
     * @param baseInfoFactory 基础服务
     */
    constructor(configFactory: IConfigService, redisFactory: RedisService, baseInfoFactory: BaseInfoFactory, proxyInfoFactory: ProxyInfoFactory);
    private createJob();
    /**
     * 注册任务
     */
    private initTask(jobName);
    /**
     * 初始化定时任务界面
     */
    initAgendash(): any;
    /**
     * 执行更换代理ip
     * @param proxyService
     * @param agendaService
     */
    executeProxy(ip?: string): Promise<any>;
    /**
     * 更改代理事件
     */
    private initRestartProxySchedule();
}
