"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_express_decorators_1 = require("ts-express-decorators");
var Agenda = require("agenda");
var Agendash = require("agendash");
var bluebird = require("bluebird");
var config_1 = require("./config");
var redis_1 = require("./redis");
var baseinfo_1 = require("./baseinfo");
var proxyinfo_1 = require("./proxyinfo");
/**
 * agenda服务
 */
var AgendaService = (function () {
    /**
     * 构造函数
     * @param configFactory 配置文件服务类
     * @param redisService  redis服务
     * @param baseInfoFactory 基础服务
     */
    function AgendaService(configFactory, redisFactory, baseInfoFactory, proxyInfoFactory) {
        var _this = this;
        this.configFactory = configFactory;
        this.redisFactory = redisFactory;
        this.baseInfoFactory = baseInfoFactory;
        this.proxyInfoFactory = proxyInfoFactory;
        // 实例化定时任务
        this.agenda = new Agenda({
            db: configFactory.config.mongo
        });
        // 启动任务
        this.agenda.on("ready", function () {
            _this.agenda.start();
            // 创建定时任务
            _this.createJob().then(_this.initTask.bind(_this));
        });
    }
    AgendaService.prototype.createJob = function () {
        var _this = this;
        var getJobsAsync = bluebird.promisify(this.agenda.jobs.bind(this.agenda));
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var baseInfo, job, jobs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        baseInfo = this.baseInfoFactory.getInfo();
                        job = this.agenda.create("setBaseInfo-" + baseInfo.ip, {});
                        return [4 /*yield*/, getJobsAsync({ name: job.attrs.name })];
                    case 1:
                        jobs = _a.sent();
                        if (jobs.length) {
                            return [2 /*return*/, resolve(job.attrs.name)];
                        }
                        job.repeatEvery("1 minutes");
                        job.save(function (err) {
                            if (err) {
                                return reject(new Error('Jobs not created'));
                            }
                            resolve(job.attrs.name);
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    };
    /**
     * 注册任务
     */
    AgendaService.prototype.initTask = function (jobName) {
        var _this = this;
        this.agenda.define(jobName, function (job, done) {
            _this.redisFactory.setBaseInfo(_this.baseInfoFactory.getInfo());
            _this.redisFactory.setProxyInfo(_this.proxyInfoFactory.getInfo());
            done && done();
        });
    };
    /**
     * 初始化定时任务界面
     */
    AgendaService.prototype.initAgendash = function () {
        return Agendash(this.agenda);
    };
    /**
     * 执行更换代理ip
     * @param proxyService
     * @param agendaService
     */
    AgendaService.prototype.executeProxy = function (ip) {
        var _this = this;
        if (ip === void 0) { ip = ""; }
        console.log(ip);
        return new Promise(function (resolve, reject) {
            var localIp = _this.baseInfoFactory.getInfo().ip;
            var job = _this.agenda.now((ip || localIp) + "-pptpsetup", {});
            if (!ip || ip == localIp) {
                _this.initRestartProxySchedule();
            }
            return resolve();
        });
    };
    /**
     * 更改代理事件
     */
    AgendaService.prototype.initRestartProxySchedule = function () {
        var _this = this;
        var ip = this.baseInfoFactory.getInfo().ip;
        this.agenda.define(ip + "-pptpsetup", function (job, done) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                ts_express_decorators_1.InjectorService.invokeMethod(this.proxyInfoFactory.initPptpsetupSchedule.bind(this.proxyInfoFactory), []);
                done && done();
                return [2 /*return*/];
            });
        }); });
    };
    return AgendaService;
}());
AgendaService = __decorate([
    ts_express_decorators_1.Service(),
    __param(0, ts_express_decorators_1.Inject(config_1.ConfigService)),
    __param(1, ts_express_decorators_1.Inject(redis_1.RedisService)),
    __param(2, ts_express_decorators_1.Inject(baseinfo_1.BaseInfoFactory)),
    __param(3, ts_express_decorators_1.Inject(proxyinfo_1.ProxyInfoFactory)),
    __metadata("design:paramtypes", [Object, redis_1.RedisService,
        baseinfo_1.BaseInfoFactory,
        proxyinfo_1.ProxyInfoFactory])
], AgendaService);
exports.AgendaService = AgendaService;
// 工厂方法注册
ts_express_decorators_1.InjectorService.factory(AgendaService, ts_express_decorators_1.InjectorService.invoke(AgendaService));
//# sourceMappingURL=agenda.js.map