"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_express_decorators_1 = require("ts-express-decorators");
var ts_log_debug_1 = require("ts-log-debug");
var shell = require("shelljs");
var bluebird = require("bluebird");
var log_func_1 = require("../decorations/log.func");
var commands = {
    poff: function (pptpChannel) {
        return "pptpsetup --delete " + pptpChannel;
    },
    pptpsetup: function (pptpChannel, account, password, server) {
        return "pptpsetup --create " + pptpChannel + " --server " + server + " --username " + account + " --password " + password + " --start";
    },
    routeAdd: "route add default gw ",
    nginxRestart: "service nginx restart",
    nginxStop: "service nginx stop",
    nginxStart: "service nginx start",
    route: "route",
    routeDelete: "route delete default gw all"
};
/**
 * 更换代理服务
 * 第一步：关闭nginx
 * 第二步：关闭pptp通道
 * 第三步：创建通道
 * 第四步：添加默认网关并且验证通道创建的地址是否在网关里面
 * 第五步：延时3s，重启nginx
 */
var ProxyService = (function () {
    function ProxyService() {
        this._pptpChannel = "crawler.pptp";
    }
    /**
     * 关闭nginx
     */
    ProxyService.prototype.closeNginx = function () {
        return new Promise(function (resolve, reject) {
            var rtn = shell.exec(commands.nginxStop, { silent: false });
            if (rtn.code !== 0) {
                return reject(new Error(rtn.stderr));
            }
            resolve();
        });
    };
    /**
     * 开启nginx
     */
    ProxyService.prototype.openNginx = function () {
        return new Promise(function (resolve, reject) {
            var rtn = shell.exec(commands.nginxStart, { silent: false });
            if (rtn.code !== 0) {
                return reject(new Error(rtn.stderr));
            }
            resolve();
        });
    };
    /**
     * 创建pptp通道
     * @param account
     * @param password
     * @param server
     */
    ProxyService.prototype.pptpsetup = function (account, password, server) {
        var _this = this;
        var datas = [], isSuccess = false, localhostIp;
        return new Promise(function (resolve, reject) {
            var pptpsetup = shell.exec(commands.pptpsetup(_this._pptpChannel, account, password, server), { silent: true, async: true });
            pptpsetup.stdout.on("data", function (data) {
                datas.push(data);
                if (/remote/i.test(datas.join(""))) {
                    isSuccess = /succeeded/i.test(datas.join(""));
                    isSuccess && (localhostIp = datas.join("").match(/\d{1,3}.\d{1,3}.\d{1,3}.\d{1,3}/ig));
                    if (isSuccess && localhostIp.length > 1) {
                        resolve(localhostIp[0]);
                    }
                }
            });
            pptpsetup.stderr.on("error", function (err) {
                reject(err);
            });
        });
    };
    /**
     * 设置路由表
     * @param lastIp ip地址
     */
    ProxyService.prototype.setRoute = function (lastIp) {
        return new Promise(function (resolve, reject) {
            var rtn = shell.exec(commands.routeAdd + lastIp, { silent: false });
            var route = shell.exec(commands.route, { silent: false }).stdout;
            ts_log_debug_1.$log.trace("success----------", lastIp, route);
            if (route.indexOf(lastIp) > 0) {
                return resolve();
            }
            return reject();
        });
    };
    /**
     * 重启nginx
     */
    ProxyService.prototype.restartNginx = function () {
        return new Promise(function (resolve, reject) {
            var rtn = shell.exec(commands.nginxStop, { silent: false });
            var rtn1 = shell.exec(commands.nginxStart, { silent: false });
            if (rtn.code != 0) {
                return reject(new Error(rtn.stderr));
            }
            if (rtn1.code != 0) {
                return reject(new Error(rtn1.stderr));
            }
            resolve();
        });
    };
    /**
     * 关闭之前创建的通道
     */
    ProxyService.prototype.poff = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            shell.exec(commands.poff(_this._pptpChannel), { silent: false });
        });
    };
    /**
     * 执行更换代理操作
     * 此处nginx作为正向代理服务器来使用
     * 因为通过了vpn拨号，因此当前机器的出口ip地址已被更换成vpn的ip
     * 从而绕过网站的反扒策略
     *
     * 第一步：关闭nginx
     * 第二步：关闭pptp通道
     * 第三步：创建通道
     * 第四步：添加默认网关并且验证通道创建的地址是否在网关里面
     * 第五步：延时3s，重启nginx
     * @param account  代理账户
     * @param password 代理密码
     * @param server   代理服务器
     */
    ProxyService.prototype.execute = function (account, password, server) {
        return __awaiter(this, void 0, void 0, function () {
            var lastIp;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.closeNginx()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.poff()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.pptpsetup(account, password, server)];
                    case 3:
                        lastIp = _a.sent();
                        return [4 /*yield*/, this.setRoute(lastIp)];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, bluebird.delay(3000)];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, this.restartNginx()];
                    case 6:
                        _a.sent();
                        return [2 /*return*/, lastIp];
                }
            });
        });
    };
    return ProxyService;
}());
__decorate([
    log_func_1.Log(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, String]),
    __metadata("design:returntype", Promise)
], ProxyService.prototype, "execute", null);
ProxyService = __decorate([
    ts_express_decorators_1.Service()
], ProxyService);
exports.ProxyService = ProxyService;
//# sourceMappingURL=proxy.js.map