"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_express_decorators_1 = require("ts-express-decorators");
var ip = require("ip");
var config_1 = require("./config");
var proxy_1 = require("./proxy");
var baseinfo_1 = require("./baseinfo");
var ts_log_debug_1 = require("ts-log-debug");
/**
 * 基础信息服务
 */
// @Service()
var ProxyInfoFactory = (function () {
    /**
     * 设置基础信息
     * 读取配置文件中maxTask字段
     */
    function ProxyInfoFactory(configFactory, baseInfoFactory) {
        this.configFactory = configFactory;
        this.baseInfoFactory = baseInfoFactory;
        this._lastUpdateAt = Date.now();
    }
    Object.defineProperty(ProxyInfoFactory.prototype, "proxyInfo", {
        /**
         * 设置代理信息
         */
        get: function () {
            return this._proxyInfo;
        },
        /**
         * 设置代理信息
         */
        set: function (val) {
            this._proxyInfo = val;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * 更改代理事件
     * @param proxyService  代理服务
     * @param agendaService 定时任务服务
     */
    ProxyInfoFactory.prototype.initPptpsetupSchedule = function (proxyService) {
        return __awaiter(this, void 0, void 0, function () {
            var info, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this._running) {
                            return [2 /*return*/];
                        }
                        if (!this._proxyInfo) {
                            throw new Error("没有设置账号等信息！");
                        }
                        if (!(this._proxyInfo.account && this._proxyInfo.password && this._proxyInfo.server)) return [3 /*break*/, 5];
                        this._running = true;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, proxyService.execute(this._proxyInfo.account, this._proxyInfo.password, this._proxyInfo.server)];
                    case 2:
                        info = _a.sent();
                        // trace info数据
                        ts_log_debug_1.$log.trace(info);
                        // 最后更改时间
                        this._lastUpdateAt = Date.now();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        this._errorMsg = e_1.message;
                        ts_log_debug_1.$log.error(e_1);
                        return [3 /*break*/, 4];
                    case 4:
                        this._running = false;
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 获取基础信息
     * pid
     * currentTask
     * maxTask
     */
    ProxyInfoFactory.prototype.getInfo = function () {
        var _a = this.configFactory.config.baseInfo, _b = _a.http, http = _b === void 0 ? { port: 0 } : _b, callIp = _a.ip;
        return {
            type: "crawler.proxy",
            pid: process.pid,
            callIp: callIp,
            callPort: http.port,
            ip: ip.address(),
            running: this._running,
            errMsg: this._errorMsg,
            proxyInfo: this._proxyInfo,
            lastUpdateAt: this._lastUpdateAt
        };
    };
    return ProxyInfoFactory;
}());
__decorate([
    ts_express_decorators_1.Inject(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [proxy_1.ProxyService]),
    __metadata("design:returntype", Promise)
], ProxyInfoFactory.prototype, "initPptpsetupSchedule", null);
ProxyInfoFactory = __decorate([
    __param(0, ts_express_decorators_1.Inject(config_1.ConfigService)), __param(1, ts_express_decorators_1.Inject(baseinfo_1.BaseInfoFactory)),
    __metadata("design:paramtypes", [config_1.ConfigService, baseinfo_1.BaseInfoFactory])
], ProxyInfoFactory);
exports.ProxyInfoFactory = ProxyInfoFactory;
// 工厂方法注册
ts_express_decorators_1.InjectorService.factory(ProxyInfoFactory, ts_express_decorators_1.InjectorService.invoke(ProxyInfoFactory));
//# sourceMappingURL=proxyinfo.js.map