import { IConfigService } from './config';
/**
 * redis的工厂服务
 */
export interface IRedisService {
    setBaseInfo(data: any): void;
}
/**
 * redis相关的服务
 */
export declare class RedisService implements IRedisService {
    private configFactory;
    private client;
    /**
     * 构造
     * 初始化redis客户端
     */
    constructor(configFactory: IConfigService);
    /**
     * 设置基础信息到redis
     * @param data 基础信息
     */
    setBaseInfo(data: any): void;
    setProxyInfo(data: any): void;
}
