"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_express_decorators_1 = require("ts-express-decorators");
var redis = require("ioredis");
var ts_log_debug_1 = require("ts-log-debug");
var config_1 = require("./config");
var _redisKey = "crawler.nodes";
var _redisProxyKey = "crawler.proxy";
/**
 * redis相关的服务
 */
var RedisService = (function () {
    /**
     * 构造
     * 初始化redis客户端
     */
    function RedisService(configFactory) {
        var _this = this;
        this.configFactory = configFactory;
        // this.client = new redis.Cluster(configFactory.config.redis.nodes);
        this.client = new redis(configFactory.config.redis.options);
        this.client.on("error", function (err) {
            ts_log_debug_1.$log.error("Redis Error " + err);
        });
        this.client.hgetall(_redisKey).then(function (data) {
            // $log.info(data);
        });
        process.on("exit", function () {
            console.log("exit");
            _this.client.hdel(_redisKey, process.pid.toString());
        });
    }
    /**
     * 设置基础信息到redis
     * @param data 基础信息
     */
    RedisService.prototype.setBaseInfo = function (data) {
        this.client.hset(_redisKey, data.ip.toString(), JSON.stringify(data)).then(function (data) {
        }, function (err) {
            ts_log_debug_1.$log.error(err);
        });
    };
    RedisService.prototype.setProxyInfo = function (data) {
        this.client.hset(_redisProxyKey, data.ip.toString(), JSON.stringify(data)).then(function (data) {
        }, function (err) {
            ts_log_debug_1.$log.error(err);
        });
    };
    return RedisService;
}());
RedisService = __decorate([
    ts_express_decorators_1.Service(),
    __param(0, ts_express_decorators_1.Inject(config_1.ConfigService)),
    __metadata("design:paramtypes", [Object])
], RedisService);
exports.RedisService = RedisService;
// 注册工厂方法
ts_express_decorators_1.InjectorService.factory(RedisService, ts_express_decorators_1.InjectorService.invoke(RedisService));
//# sourceMappingURL=redis.js.map